SystemOrganization addCategory: #'Pier-Core'!

WAPackage subclass: #PRPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Core'!

!PRPackage class methodsFor: 'accessing' stamp: 'jf 9/23/2009 15:01'!
pierCore
	^ self new
		name: 'Pier-Core';
		addDependency: 'Magritte-Model';
		addDependency: 'Seaside-Platform';
		yourself! !

WAPlatformError subclass: #PRError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Core'!

WAPlatformObject subclass: #PRBasicObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Core'!

!PRBasicObject class methodsFor: 'error handling' stamp: 'jf 9/18/2009 15:40'!
defaultErrorClass
	^ PRError! !

!PRBasicObject class methodsFor: 'license' stamp: 'jf 9/24/2009 14:09'!
pierLicense
	"Return a string with the license of the package. This string shall not be removed or altered in any case."

	^ 'The MIT License

Copyright (c) 2003-' , Date today year printString , ' Lukas Renggli, renggli at gmail.com

Copyright (c) 2003-' , Date today year printString , ' Contributors

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.'! !

PRBasicObject subclass: #PRObject
	instanceVariableNames: 'properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Core'!

!PRObject commentStamp: 'jf 9/18/2009 15:47' prior: 0!
I am a superclass of most objects within Pier. I hold a dictionary of properties, so that users can easily annotate me with new values. I am visitable.!

!PRObject class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ true! !

!PRObject class methodsFor: 'instance-creation' stamp: 'jf 9/18/2009 15:41'!
new
	"Create a new instance of this class and checks if it isn't abstract."

	self isAbstract
		ifTrue: [ self error: self name , ' is abstract.' ].
	^ super new! !

!PRObject class methodsFor: 'reflection' stamp: 'lr 3/9/2006 11:30'!
withAllConcreteClasses
	^ Array streamContents: [ :stream |
		self withAllConcreteClassesDo: [ :each |
			stream nextPut: each ] ]! !

!PRObject class methodsFor: 'reflection' stamp: 'lr 3/9/2006 11:30'!
withAllConcreteClassesDo: aBlock
	self withAllSubclassesDo: [ :each |
		each isAbstract ifFalse: [
			aBlock value: each ] ]! !

!PRObject methodsFor: 'visiting' stamp: 'lr 4/10/2007 21:49'!
accept: aVisitor
	"Dispatch to ==aVisitor== depending on the receiver."! !

!PRObject methodsFor: 'private' stamp: 'lr 3/5/2007 14:03'!
errorPropertyNotFound: aSelector
	MAPropertyError signal: 'Property ' , aSelector , ' not found.'! !

!PRObject methodsFor: 'testing' stamp: 'lr 4/10/2007 21:49'!
hasProperty: aKey
	"Test if the property ==aKey== is defined within the receiver."

	^ self properties includesKey: aKey! !

!PRObject methodsFor: 'copying' stamp: 'lr 3/9/2006 11:29'!
postCopy
	super postCopy.
	properties := properties copy! !

!PRObject methodsFor: 'copying' stamp: 'lr 3/9/2006 11:29'!
postCopyTo: anObject! !

!PRObject methodsFor: 'accessing-properties' stamp: 'lr 5/28/2006 17:01'!
properties
	"Answer the property dictionary of the receiver."

	^ properties ifNil: [ properties := Dictionary new ]! !

!PRObject methodsFor: 'accessing-properties' stamp: 'lr 4/10/2007 21:49'!
propertyAt: aKey
	"Answer the value of the property ==aKey==, raises an error if the property doesn't exist."

	^ self propertyAt: aKey ifAbsent: [ self errorPropertyNotFound: aKey ]! !

!PRObject methodsFor: 'accessing-properties' stamp: 'lr 4/10/2007 21:49'!
propertyAt: aKey ifAbsent: aBlock
	"Answer the value of the property ==aKey==, or the result of ==aBlock== if the property doesn't exist."

	^ self properties at: aKey ifAbsent: aBlock! !

!PRObject methodsFor: 'accessing-properties' stamp: 'lr 4/10/2007 21:49'!
propertyAt: aKey ifAbsentPut: aBlock
	"Answer the value of the property ==aKey==, or if the property doesn't exist adds and answers the result of evaluating ==aBlock==."

	^ self properties at: aKey ifAbsentPut: aBlock! !

!PRObject methodsFor: 'accessing-properties' stamp: 'lr 4/10/2007 21:50'!
propertyAt: aKey put: aValue
	"Adds or replaces the property ==aKey== with ==aValue==."

	^ self properties at: aKey put: aValue! !
